Responses
Retrieve a model response
Retrieves a model response with the given ID.
Pfadparameter
response_id
string
Erforderlich
The response id path parameter.
Abfrageparameter
include[]
OpenAI.IncludeEnum[]
The includables query parameter.
stream
boolean
The stream query parameter.
starting_after
integer
The sequence number of the event after which to start streaming.
Headerparameter
x-ms-user-identity
string
Opaque per-user identity string used to scope endpoint-scoped data to a specific end user. The caller must have the agents/endpoints/UserIdentityImpersonation/action RBAC permission.
Antworten
The request has succeeded.
Header
x-agent-session-id
string
Session ID for this request. Only present for hosted agent responses. Returns the provided session ID or an auto-generated one if not provided in the request.
Text
metadata
OpenAI.Metadata | null
Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
user
string | null
This field is being replaced by safety_identifier and prompt_cache_key. Use prompt_cache_key instead to maintain caching optimizations. A stable identifier for your end-users. Used to boost cache hit rates by better bucketing similar requests and to help OpenAI detect and prevent abuse. Learn more.
prompt_cache_retention
enum
model
string
The model deployment to use for the creation of this response.
text
OpenAI.ResponseTextParam
Configuration options for a text response from the model. Can be plain text or structured JSON data. Learn more: - Text inputs and outputs - Structured Outputs
format
json_schema | text | json_object
An object specifying the format that the model must output. Configuring { "type": "json_schema" } enables Structured Outputs, which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide. The default format is { "type": "text" } with no additional options. Not recommended for gpt-4o and newer models:* Setting to { "type": "json_object" } enables the older JSON mode, which ensures the message the model generates is valid JSON. Using json_schema is preferred for models that support it.
json_schema
OpenAI.TextResponseFormatJsonSchema
JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
type
enum
Erforderlich
The type of response format being defined. Always json_schema.
description
string
A description of what the response format is for, used by the model to determine how to respond in the format.
name
string
Erforderlich
The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
schema
OpenAI.ResponseFormatJsonSchemaSchema
Erforderlich
The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
text
OpenAI.TextResponseFormatConfigurationResponseFormatText
Default response format. Used to generate text responses.
type
enum
Erforderlich
The type of response format being defined. Always text.
json_object
OpenAI.TextResponseFormatConfigurationResponseFormatJsonObject
JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.
type
enum
Erforderlich
The type of response format being defined. Always json_object.
verbosity
enum
Constrains the verbosity of the model's response. Lower values will result in more concise responses, while higher values will result in more verbose responses. Currently supported values are low, medium, and high. The default is medium.
tools
OpenAI.Tool[]
An array of tools the model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter. We support the following categories of tools: - Built-in tools: Tools that are provided by OpenAI that extend the model's capabilities, like web search or file search. Learn more about built-in tools. - MCP Tools: Integrations with third-party systems via custom MCP servers or predefined connectors such as Google Drive and SharePoint. Learn more about MCP Tools. - Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code with strongly typed arguments and outputs. Learn more about function calling. You can also use custom tools to call your own code.
tool_choice
enum | OpenAI.ToolChoiceParam
enum
Controls which (if any) tool is called by the model. none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools.
function
OpenAI.ToolChoiceFunction
Use this option to force the model to call a specific function.
type
enum
Erforderlich
For function calling, the type is always function.
name
string
Erforderlich
The name of the function to call.
mcp
OpenAI.ToolChoiceMCP
Use this option to force the model to call a specific tool on a remote MCP server.
type
enum
Erforderlich
For MCP tools, the type is always mcp.
server_label
string
Erforderlich
The label of the MCP server to use.
allowed_tools
OpenAI.ToolChoiceAllowed
Constrains the tools available to the model to a pre-defined set.
type
enum
Erforderlich
Allowed tool configuration type. Always allowed_tools.
mode
enum
Erforderlich
Constrains the tools available to the model to a pre-defined set. auto allows the model to pick from among the allowed tools and generate a message. required requires the model to call one or more of the allowed tools.
tools
object[]
Erforderlich
A list of tool definitions that the model should be allowed to call. For the Responses API, the list of tool definitions might look like: json [ { "type": "function", "name": "get_weather" }, { "type": "mcp", "server_label": "deepwiki" }, { "type": "image_generation" } ]
custom
OpenAI.ToolChoiceCustom
Use this option to force the model to call a specific custom tool.
type
enum
Erforderlich
For custom tool calling, the type is always custom.
name
string
Erforderlich
The name of the custom tool to call.
programmatic_tool_calling
OpenAI.SpecificProgrammaticToolCallingParam
type
enum
Erforderlich
The tool to call. Always programmatic_tool_calling.
apply_patch
OpenAI.SpecificApplyPatchParam
Forces the model to call the apply_patch tool when executing a tool call.
type
enum
Erforderlich
The tool to call. Always apply_patch.
shell
OpenAI.SpecificFunctionShellParam
Forces the model to call the shell tool when a tool call is required.
type
enum
Erforderlich
The tool to call. Always shell.
file_search
OpenAI.ToolChoiceFileSearch
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
web_search_preview
OpenAI.ToolChoiceWebSearchPreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
computer_use_preview
OpenAI.ToolChoiceComputerUsePreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
web_search_preview_2025_03_11
OpenAI.ToolChoiceWebSearchPreview20250311
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
image_generation
OpenAI.ToolChoiceImageGeneration
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
code_interpreter
OpenAI.ToolChoiceCodeInterpreter
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
computer
OpenAI.ToolChoiceComputer
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
computer_use
OpenAI.ToolChoiceComputerUse
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
prompt
OpenAI.Prompt
Reference to a prompt template and its variables. Learn more.
id
string
Erforderlich
The unique identifier of the prompt template to use.
variables
OpenAI.ResponsePromptVariables | null
Optional map of values to substitute in for variables in your prompt. The substitution values can either be strings, or other Response input types like images or files.
[key: string]
string | OpenAI.InputTextContent | OpenAI.InputImageContent | OpenAI.InputFileContent
type
enum
Erforderlich
The type of the input item. Always input_text.
text
string
Erforderlich
The text input to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
Erforderlich
The breakpoint mode. Always explicit.
type
enum
Erforderlich
The type of the input item. Always input_image.
detail
enum
Erforderlich
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
Erforderlich
The breakpoint mode. Always explicit.
type
enum
Erforderlich
The type of the input item. Always input_file.
filename
string
The name of the file to be sent to the model.
file_data
string
The content of the file to be sent to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
Erforderlich
The breakpoint mode. Always explicit.
file_url
string
The URL of the file to be sent to the model.
detail
enum
service_tier
enum
Specifies the processing type used for serving the request. - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'. - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model. - If set to 'flex', then the request will be processed with the Flex Processing service tier. - To opt-in to Fast mode at the request level, include the service_tier=fast or service_tier=priority parameter for Responses or Chat Completions. The response will show service_tier=priority regardless of if you specify service_tier=fast or priority in your request. - If set to 'ultrafast', then the request will be processed with the access-controlled Ultrafast Processing service tier. This tier is currently available for gpt-5.6-sol; a response served through it will show service_tier=ultrafast. - When not set, the default behavior is 'auto'. When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.
truncation
enum
id
string
Erforderlich
Unique identifier for this Response.
object
enum
Erforderlich
The object type of this resource - always set to response.
status
enum
The status of the response generation. One of completed, failed, in_progress, cancelled, queued, or incomplete.
access_programs
OpenAI.AccessProgramsBody | null
Erforderlich
cyber
enum
Erforderlich
created_at
integer
Erforderlich
Unix timestamp (in seconds) of when this Response was created.
error
OpenAI.ResponseError | null
Erforderlich
An error object returned when the model fails to generate a Response.
type
string | null
The original error type, or null if it was not recorded.
param
string | null
The request parameter associated with the error, or null if none was recorded.
code
enum
Erforderlich
The error code for the response.
message
string
Erforderlich
A human-readable description of the error.
misalignment
OpenAI.MisalignmentErrorDetailsResource
error_type
string | enum
enum
detailed_explanation
string
The public explanation for this block.
steer
OpenAI._MisalignmentSteer
message
string
Erforderlich
The public continuation instruction.
incomplete_details
OpenAI.ResponseIncompleteDetails | null
Erforderlich
reason
enum
output
OpenAI.OutputItem[]
Erforderlich
An array of content items generated by the model. - The length and order of items in the output array is dependent on the model's response. - Rather than accessing the first item in the output array and assuming it's an assistant message with the content generated by the model, you might consider using the output_text property where supported in SDKs.
reasoning
OpenAI.Reasoning | null
Configuration options for reasoning models.
mode
string | enum
enum
effort
string | enum | null
Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, xhigh, and max. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response. Not all reasoning models support every value. See the reasoning guide for model-specific support.
enum
summary
enum
context
enum
generate_summary
enum
instructions
string | OpenAI.InputItem[] | null
Erforderlich
usage
OpenAI.ResponseUsage | null
Represents token usage details including input tokens, output tokens, a breakdown of output tokens, and the total tokens used.
input_tokens_details
OpenAI.ResponseUsageInputTokensDetails
Erforderlich
output_tokens_details
OpenAI.ResponseUsageOutputTokensDetails
Erforderlich
prompt_cache_options
OpenAI.PromptCacheOptions
The prompt-caching options that were applied to the response. Supported for gpt-5.6 and later models.
ttl
enum
Erforderlich
mode
enum
Erforderlich
prompt_cache_diagnostics
cache_miss | cache_hit | comparison_response_not_found | unavailable
Prompt cache diagnostics requested for this response.
cache_miss
OpenAI.PromptCacheMissDiagnosticsBody
type
enum
Erforderlich
reason
enum
Erforderlich
cache_hit
OpenAI.PromptCacheHitDiagnosticsBody
type
enum
Erforderlich
comparison_response_not_found
OpenAI.PromptCacheComparisonResponseNotFoundDiagnosticsBody
type
enum
Erforderlich
unavailable
OpenAI.PromptCacheUnavailableDiagnosticsBody
type
enum
Erforderlich
moderation
OpenAI.Moderation | null
Moderation results or errors for the response input and output.
input
error | moderation_result
Erforderlich
Moderation results or an error for a response moderation check.
error
OpenAI.ModerationErrorBody
An error produced while attempting moderation for the response input or output.
type
enum
Erforderlich
The object type, which was always error for moderation failures.
code
string
Erforderlich
The error code.
message
string
Erforderlich
The error message.
moderation_result
OpenAI.ModerationResultBody
A moderation result produced for the response input or output.
type
enum
Erforderlich
The object type, which was always moderation_result for successful moderation results.
model
string
Erforderlich
The moderation model that produced this result.
flagged
boolean
Erforderlich
A boolean indicating whether the content was flagged by any category.
categories
object
Erforderlich
A dictionary of moderation categories to booleans, True if the input is flagged under this category.
category_scores
object
Erforderlich
A dictionary of moderation categories to scores.
category_applied_input_types
object
Erforderlich
Which modalities of input are reflected by the score for each category.
output
error | moderation_result
Erforderlich
Moderation results or an error for a response moderation check.
error
OpenAI.ModerationErrorBody
An error produced while attempting moderation for the response input or output.
type
enum
Erforderlich
The object type, which was always error for moderation failures.
code
string
Erforderlich
The error code.
message
string
Erforderlich
The error message.
moderation_result
OpenAI.ModerationResultBody
A moderation result produced for the response input or output.
type
enum
Erforderlich
The object type, which was always moderation_result for successful moderation results.
model
string
Erforderlich
The moderation model that produced this result.
flagged
boolean
Erforderlich
A boolean indicating whether the content was flagged by any category.
categories
object
Erforderlich
A dictionary of moderation categories to booleans, True if the input is flagged under this category.
category_scores
object
Erforderlich
A dictionary of moderation categories to scores.
category_applied_input_types
object
Erforderlich
Which modalities of input are reflected by the score for each category.
parallel_tool_calls
boolean
Erforderlich
Whether to allow the model to run tool calls in parallel.
conversation
OpenAI.ResponseConversation | null
The conversation that this response belonged to. Input items and output items from this response were automatically added to this conversation.
id
string
Erforderlich
The unique ID of the conversation that this response was associated with.
agent_reference
AgentReference | null
Erforderlich
The agent used for this response
type
enum
Erforderlich
name
string
Erforderlich
The name of the agent.
version
string
The version identifier of the agent.
model_selection_details
ModelSelectionDetails
Model selection metadata providing visibility into routing decisions.
model_router_details
ModelRouterDetails
Erforderlich
Routing decision metadata from Model Router.
mode
string | enum
Erforderlich
The routing mode used by Model Router for the request.
enum
session_affinity
SessionAffinityDetails
Effective Model Router session affinity metadata for a request.
mode
string | enum
Erforderlich
Effective modes reported for Model Router session affinity.
enum
source
string | enum
Conversation identifier sources supported by Model Router session affinity.
enum
decision
string | enum
Final outcomes reported for Model Router session affinity.
enum
routing_trace
RoutingTraceEntry[]
Erforderlich
Ordered trace of routing decisions. Contains one entry for Chat Completions, and may contain multiple entries for Responses API or agent scenarios where multiple inference turns occur.
content_filters
ContentFilterResult[]
The content filter evaluation results.
type
enum
Erforderlich
The type of the event. Always response.audio.delta.
delta
string
Erforderlich
A chunk of Base64 encoded response audio bytes.
type
enum
Erforderlich
The type of the event. Always response.audio.transcript.delta.
delta
string
Erforderlich
The partial transcript of the audio response.
type
enum
Erforderlich
The type of the event. Always response.code_interpreter_call_code.delta.
item_id
string
Erforderlich
The unique identifier of the code interpreter tool call item.
delta
string
Erforderlich
The partial code snippet being streamed by the code interpreter.
type
enum
Erforderlich
The type of the event. Always response.code_interpreter_call.in_progress.
item_id
string
Erforderlich
The unique identifier of the code interpreter tool call item.
type
enum
Erforderlich
The type of the event. Always response.code_interpreter_call.interpreting.
item_id
string
Erforderlich
The unique identifier of the code interpreter tool call item.
type
enum
Erforderlich
The type of the event. Always response.content_part.added.
item_id
string
Erforderlich
The ID of the output item that the content part was added to.
part
output_text | refusal | reasoning_text
Erforderlich
output_text
OpenAI.OutputContentOutputTextContent
A text output from the model.
type
enum
Erforderlich
The type of the output text. Always output_text.
text
string
Erforderlich
The text output from the model.
annotations
OpenAI.Annotation[]
The annotations of the text output.
refusal
OpenAI.OutputContentRefusalContent
A refusal from the model.
type
enum
Erforderlich
The type of the refusal. Always refusal.
refusal
string
Erforderlich
The refusal explanation from the model.
reasoning_text
OpenAI.OutputContentReasoningTextContent
Reasoning text from the model.
type
enum
Erforderlich
The type of the reasoning text. Always reasoning_text.
text
string
Erforderlich
The reasoning text from the model.
type
enum
Erforderlich
The type of the event. Always response.created.
response
OpenAI.Response
Erforderlich
metadata
OpenAI.Metadata | null
Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
user
string | null
This field is being replaced by safety_identifier and prompt_cache_key. Use prompt_cache_key instead to maintain caching optimizations. A stable identifier for your end-users. Used to boost cache hit rates by better bucketing similar requests and to help OpenAI detect and prevent abuse. Learn more.
prompt_cache_retention
enum
model
string
The model deployment to use for the creation of this response.
text
OpenAI.ResponseTextParam
Configuration options for a text response from the model. Can be plain text or structured JSON data. Learn more: - Text inputs and outputs - Structured Outputs
format
json_schema | text | json_object
An object specifying the format that the model must output. Configuring { "type": "json_schema" } enables Structured Outputs, which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide. The default format is { "type": "text" } with no additional options. Not recommended for gpt-4o and newer models:* Setting to { "type": "json_object" } enables the older JSON mode, which ensures the message the model generates is valid JSON. Using json_schema is preferred for models that support it.
json_schema
OpenAI.TextResponseFormatJsonSchema
JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
type
enum
Erforderlich
The type of response format being defined. Always json_schema.
description
string
A description of what the response format is for, used by the model to determine how to respond in the format.
name
string
Erforderlich
The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
schema
OpenAI.ResponseFormatJsonSchemaSchema
Erforderlich
The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
text
OpenAI.TextResponseFormatConfigurationResponseFormatText
Default response format. Used to generate text responses.
type
enum
Erforderlich
The type of response format being defined. Always text.
json_object
OpenAI.TextResponseFormatConfigurationResponseFormatJsonObject
JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.
type
enum
Erforderlich
The type of response format being defined. Always json_object.
verbosity
enum
Constrains the verbosity of the model's response. Lower values will result in more concise responses, while higher values will result in more verbose responses. Currently supported values are low, medium, and high. The default is medium.
tools
OpenAI.Tool[]
An array of tools the model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter. We support the following categories of tools: - Built-in tools: Tools that are provided by OpenAI that extend the model's capabilities, like web search or file search. Learn more about built-in tools. - MCP Tools: Integrations with third-party systems via custom MCP servers or predefined connectors such as Google Drive and SharePoint. Learn more about MCP Tools. - Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code with strongly typed arguments and outputs. Learn more about function calling. You can also use custom tools to call your own code.
tool_choice
enum | OpenAI.ToolChoiceParam
enum
Controls which (if any) tool is called by the model. none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools.
function
OpenAI.ToolChoiceFunction
Use this option to force the model to call a specific function.
type
enum
Erforderlich
For function calling, the type is always function.
name
string
Erforderlich
The name of the function to call.
mcp
OpenAI.ToolChoiceMCP
Use this option to force the model to call a specific tool on a remote MCP server.
type
enum
Erforderlich
For MCP tools, the type is always mcp.
server_label
string
Erforderlich
The label of the MCP server to use.
allowed_tools
OpenAI.ToolChoiceAllowed
Constrains the tools available to the model to a pre-defined set.
type
enum
Erforderlich
Allowed tool configuration type. Always allowed_tools.
mode
enum
Erforderlich
Constrains the tools available to the model to a pre-defined set. auto allows the model to pick from among the allowed tools and generate a message. required requires the model to call one or more of the allowed tools.
tools
object[]
Erforderlich
A list of tool definitions that the model should be allowed to call. For the Responses API, the list of tool definitions might look like: json [ { "type": "function", "name": "get_weather" }, { "type": "mcp", "server_label": "deepwiki" }, { "type": "image_generation" } ]
custom
OpenAI.ToolChoiceCustom
Use this option to force the model to call a specific custom tool.
type
enum
Erforderlich
For custom tool calling, the type is always custom.
name
string
Erforderlich
The name of the custom tool to call.
programmatic_tool_calling
OpenAI.SpecificProgrammaticToolCallingParam
type
enum
Erforderlich
The tool to call. Always programmatic_tool_calling.
apply_patch
OpenAI.SpecificApplyPatchParam
Forces the model to call the apply_patch tool when executing a tool call.
type
enum
Erforderlich
The tool to call. Always apply_patch.
shell
OpenAI.SpecificFunctionShellParam
Forces the model to call the shell tool when a tool call is required.
type
enum
Erforderlich
The tool to call. Always shell.
file_search
OpenAI.ToolChoiceFileSearch
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
web_search_preview
OpenAI.ToolChoiceWebSearchPreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
computer_use_preview
OpenAI.ToolChoiceComputerUsePreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
web_search_preview_2025_03_11
OpenAI.ToolChoiceWebSearchPreview20250311
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
image_generation
OpenAI.ToolChoiceImageGeneration
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
code_interpreter
OpenAI.ToolChoiceCodeInterpreter
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
computer
OpenAI.ToolChoiceComputer
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
computer_use
OpenAI.ToolChoiceComputerUse
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
prompt
OpenAI.Prompt
Reference to a prompt template and its variables. Learn more.
id
string
Erforderlich
The unique identifier of the prompt template to use.
variables
OpenAI.ResponsePromptVariables | null
Optional map of values to substitute in for variables in your prompt. The substitution values can either be strings, or other Response input types like images or files.
[key: string]
string | OpenAI.InputTextContent | OpenAI.InputImageContent | OpenAI.InputFileContent
type
enum
Erforderlich
The type of the input item. Always input_text.
text
string
Erforderlich
The text input to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
Erforderlich
The breakpoint mode. Always explicit.
type
enum
Erforderlich
The type of the input item. Always input_image.
detail
enum
Erforderlich
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
Erforderlich
The breakpoint mode. Always explicit.
type
enum
Erforderlich
The type of the input item. Always input_file.
filename
string
The name of the file to be sent to the model.
file_data
string
The content of the file to be sent to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
Erforderlich
The breakpoint mode. Always explicit.
file_url
string
The URL of the file to be sent to the model.
detail
enum
service_tier
enum
Specifies the processing type used for serving the request. - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'. - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model. - If set to 'flex', then the request will be processed with the Flex Processing service tier. - To opt-in to Fast mode at the request level, include the service_tier=fast or service_tier=priority parameter for Responses or Chat Completions. The response will show service_tier=priority regardless of if you specify service_tier=fast or priority in your request. - If set to 'ultrafast', then the request will be processed with the access-controlled Ultrafast Processing service tier. This tier is currently available for gpt-5.6-sol; a response served through it will show service_tier=ultrafast. - When not set, the default behavior is 'auto'. When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.
truncation
enum
id
string
Erforderlich
Unique identifier for this Response.
object
enum
Erforderlich
The object type of this resource - always set to response.
status
enum
The status of the response generation. One of completed, failed, in_progress, cancelled, queued, or incomplete.
access_programs
OpenAI.AccessProgramsBody | null
Erforderlich
cyber
enum
Erforderlich
created_at
integer
Erforderlich
Unix timestamp (in seconds) of when this Response was created.
error
OpenAI.ResponseError | null
Erforderlich
An error object returned when the model fails to generate a Response.
type
string | null
The original error type, or null if it was not recorded.
param
string | null
The request parameter associated with the error, or null if none was recorded.
code
enum
Erforderlich
The error code for the response.
message
string
Erforderlich
A human-readable description of the error.
misalignment
OpenAI.MisalignmentErrorDetailsResource
error_type
string | enum
enum
detailed_explanation
string
The public explanation for this block.
steer
OpenAI._MisalignmentSteer
message
string
Erforderlich
The public continuation instruction.
incomplete_details
OpenAI.ResponseIncompleteDetails | null
Erforderlich
reason
enum
output
OpenAI.OutputItem[]
Erforderlich
An array of content items generated by the model. - The length and order of items in the output array is dependent on the model's response. - Rather than accessing the first item in the output array and assuming it's an assistant message with the content generated by the model, you might consider using the output_text property where supported in SDKs.
reasoning
OpenAI.Reasoning | null
Configuration options for reasoning models.
mode
string | enum
enum
effort
string | enum | null
Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, xhigh, and max. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response. Not all reasoning models support every value. See the reasoning guide for model-specific support.
enum
summary
enum
context
enum
generate_summary
enum
instructions
string | OpenAI.InputItem[] | null
Erforderlich
usage
OpenAI.ResponseUsage | null
Represents token usage details including input tokens, output tokens, a breakdown of output tokens, and the total tokens used.
input_tokens_details
OpenAI.ResponseUsageInputTokensDetails
Erforderlich
output_tokens_details
OpenAI.ResponseUsageOutputTokensDetails
Erforderlich
prompt_cache_options
OpenAI.PromptCacheOptions
The prompt-caching options that were applied to the response. Supported for gpt-5.6 and later models.
ttl
enum
Erforderlich
mode
enum
Erforderlich
prompt_cache_diagnostics
cache_miss | cache_hit | comparison_response_not_found | unavailable
Prompt cache diagnostics requested for this response.
cache_miss
OpenAI.PromptCacheMissDiagnosticsBody
type
enum
Erforderlich
reason
enum
Erforderlich
cache_hit
OpenAI.PromptCacheHitDiagnosticsBody
type
enum
Erforderlich
comparison_response_not_found
OpenAI.PromptCacheComparisonResponseNotFoundDiagnosticsBody
type
enum
Erforderlich
unavailable
OpenAI.PromptCacheUnavailableDiagnosticsBody
type
enum
Erforderlich
moderation
OpenAI.Moderation | null
Moderation results or errors for the response input and output.
input
error | moderation_result
Erforderlich
Moderation results or an error for a response moderation check.
error
OpenAI.ModerationErrorBody
An error produced while attempting moderation for the response input or output.
type
enum
Erforderlich
The object type, which was always error for moderation failures.
code
string
Erforderlich
The error code.
message
string
Erforderlich
The error message.
moderation_result
OpenAI.ModerationResultBody
A moderation result produced for the response input or output.
type
enum
Erforderlich
The object type, which was always moderation_result for successful moderation results.
model
string
Erforderlich
The moderation model that produced this result.
flagged
boolean
Erforderlich
A boolean indicating whether the content was flagged by any category.
categories
object
Erforderlich
A dictionary of moderation categories to booleans, True if the input is flagged under this category.
category_scores
object
Erforderlich
A dictionary of moderation categories to scores.
category_applied_input_types
object
Erforderlich
Which modalities of input are reflected by the score for each category.
output
error | moderation_result
Erforderlich
Moderation results or an error for a response moderation check.
error
OpenAI.ModerationErrorBody
An error produced while attempting moderation for the response input or output.
type
enum
Erforderlich
The object type, which was always error for moderation failures.
code
string
Erforderlich
The error code.
message
string
Erforderlich
The error message.
moderation_result
OpenAI.ModerationResultBody
A moderation result produced for the response input or output.
type
enum
Erforderlich
The object type, which was always moderation_result for successful moderation results.
model
string
Erforderlich
The moderation model that produced this result.
flagged
boolean
Erforderlich
A boolean indicating whether the content was flagged by any category.
categories
object
Erforderlich
A dictionary of moderation categories to booleans, True if the input is flagged under this category.
category_scores
object
Erforderlich
A dictionary of moderation categories to scores.
category_applied_input_types
object
Erforderlich
Which modalities of input are reflected by the score for each category.
parallel_tool_calls
boolean
Erforderlich
Whether to allow the model to run tool calls in parallel.
conversation
OpenAI.ResponseConversation | null
The conversation that this response belonged to. Input items and output items from this response were automatically added to this conversation.
id
string
Erforderlich
The unique ID of the conversation that this response was associated with.
agent_reference
AgentReference | null
Erforderlich
The agent used for this response
type
enum
Erforderlich
name
string
Erforderlich
The name of the agent.
version
string
The version identifier of the agent.
model_selection_details
ModelSelectionDetails
Model selection metadata providing visibility into routing decisions.
model_router_details
ModelRouterDetails
Erforderlich
Routing decision metadata from Model Router.
mode
string | enum
Erforderlich
The routing mode used by Model Router for the request.
enum
session_affinity
SessionAffinityDetails
Effective Model Router session affinity metadata for a request.
mode
string | enum
Erforderlich
Effective modes reported for Model Router session affinity.
enum
source
string | enum
Conversation identifier sources supported by Model Router session affinity.
enum
decision
string | enum
Final outcomes reported for Model Router session affinity.
enum
routing_trace
RoutingTraceEntry[]
Erforderlich
Ordered trace of routing decisions. Contains one entry for Chat Completions, and may contain multiple entries for Responses API or agent scenarios where multiple inference turns occur.
content_filters
ContentFilterResult[]
The content filter evaluation results.
type
enum
Erforderlich
The type of the event. Always error.
message
string
Erforderlich
The error message.
type
enum
Erforderlich
The type of the event. Always response.file_search_call.in_progress.
item_id
string
Erforderlich
The ID of the output item that the file search call is initiated.
type
enum
Erforderlich
The type of the event. Always response.file_search_call.searching.
item_id
string
Erforderlich
The ID of the output item that the file search call is initiated.
type
enum
Erforderlich
The type of the event. Always response.function_call_arguments.delta.
item_id
string
Erforderlich
The ID of the output item that the function-call arguments delta is added to.
delta
string
Erforderlich
The function-call arguments delta that is added.
type
enum
Erforderlich
The type of the event. Always response.in_progress.
response
OpenAI.Response
Erforderlich
metadata
OpenAI.Metadata | null
Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
user
string | null
This field is being replaced by safety_identifier and prompt_cache_key. Use prompt_cache_key instead to maintain caching optimizations. A stable identifier for your end-users. Used to boost cache hit rates by better bucketing similar requests and to help OpenAI detect and prevent abuse. Learn more.
prompt_cache_retention
enum
model
string
The model deployment to use for the creation of this response.
text
OpenAI.ResponseTextParam
Configuration options for a text response from the model. Can be plain text or structured JSON data. Learn more: - Text inputs and outputs - Structured Outputs
format
json_schema | text | json_object
An object specifying the format that the model must output. Configuring { "type": "json_schema" } enables Structured Outputs, which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide. The default format is { "type": "text" } with no additional options. Not recommended for gpt-4o and newer models:* Setting to { "type": "json_object" } enables the older JSON mode, which ensures the message the model generates is valid JSON. Using json_schema is preferred for models that support it.
json_schema
OpenAI.TextResponseFormatJsonSchema
JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
type
enum
Erforderlich
The type of response format being defined. Always json_schema.
description
string
A description of what the response format is for, used by the model to determine how to respond in the format.
name
string
Erforderlich
The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
schema
OpenAI.ResponseFormatJsonSchemaSchema
Erforderlich
The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
text
OpenAI.TextResponseFormatConfigurationResponseFormatText
Default response format. Used to generate text responses.
type
enum
Erforderlich
The type of response format being defined. Always text.
json_object
OpenAI.TextResponseFormatConfigurationResponseFormatJsonObject
JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.
type
enum
Erforderlich
The type of response format being defined. Always json_object.
verbosity
enum
Constrains the verbosity of the model's response. Lower values will result in more concise responses, while higher values will result in more verbose responses. Currently supported values are low, medium, and high. The default is medium.
tools
OpenAI.Tool[]
An array of tools the model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter. We support the following categories of tools: - Built-in tools: Tools that are provided by OpenAI that extend the model's capabilities, like web search or file search. Learn more about built-in tools. - MCP Tools: Integrations with third-party systems via custom MCP servers or predefined connectors such as Google Drive and SharePoint. Learn more about MCP Tools. - Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code with strongly typed arguments and outputs. Learn more about function calling. You can also use custom tools to call your own code.
tool_choice
enum | OpenAI.ToolChoiceParam
enum
Controls which (if any) tool is called by the model. none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools.
function
OpenAI.ToolChoiceFunction
Use this option to force the model to call a specific function.
type
enum
Erforderlich
For function calling, the type is always function.
name
string
Erforderlich
The name of the function to call.
mcp
OpenAI.ToolChoiceMCP
Use this option to force the model to call a specific tool on a remote MCP server.
type
enum
Erforderlich
For MCP tools, the type is always mcp.
server_label
string
Erforderlich
The label of the MCP server to use.
allowed_tools
OpenAI.ToolChoiceAllowed
Constrains the tools available to the model to a pre-defined set.
type
enum
Erforderlich
Allowed tool configuration type. Always allowed_tools.
mode
enum
Erforderlich
Constrains the tools available to the model to a pre-defined set. auto allows the model to pick from among the allowed tools and generate a message. required requires the model to call one or more of the allowed tools.
tools
object[]
Erforderlich
A list of tool definitions that the model should be allowed to call. For the Responses API, the list of tool definitions might look like: json [ { "type": "function", "name": "get_weather" }, { "type": "mcp", "server_label": "deepwiki" }, { "type": "image_generation" } ]
custom
OpenAI.ToolChoiceCustom
Use this option to force the model to call a specific custom tool.
type
enum
Erforderlich
For custom tool calling, the type is always custom.
name
string
Erforderlich
The name of the custom tool to call.
programmatic_tool_calling
OpenAI.SpecificProgrammaticToolCallingParam
type
enum
Erforderlich
The tool to call. Always programmatic_tool_calling.
apply_patch
OpenAI.SpecificApplyPatchParam
Forces the model to call the apply_patch tool when executing a tool call.
type
enum
Erforderlich
The tool to call. Always apply_patch.
shell
OpenAI.SpecificFunctionShellParam
Forces the model to call the shell tool when a tool call is required.
type
enum
Erforderlich
The tool to call. Always shell.
file_search
OpenAI.ToolChoiceFileSearch
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
web_search_preview
OpenAI.ToolChoiceWebSearchPreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
computer_use_preview
OpenAI.ToolChoiceComputerUsePreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
web_search_preview_2025_03_11
OpenAI.ToolChoiceWebSearchPreview20250311
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
image_generation
OpenAI.ToolChoiceImageGeneration
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
code_interpreter
OpenAI.ToolChoiceCodeInterpreter
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
computer
OpenAI.ToolChoiceComputer
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
computer_use
OpenAI.ToolChoiceComputerUse
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
prompt
OpenAI.Prompt
Reference to a prompt template and its variables. Learn more.
id
string
Erforderlich
The unique identifier of the prompt template to use.
variables
OpenAI.ResponsePromptVariables | null
Optional map of values to substitute in for variables in your prompt. The substitution values can either be strings, or other Response input types like images or files.
[key: string]
string | OpenAI.InputTextContent | OpenAI.InputImageContent | OpenAI.InputFileContent
type
enum
Erforderlich
The type of the input item. Always input_text.
text
string
Erforderlich
The text input to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
Erforderlich
The breakpoint mode. Always explicit.
type
enum
Erforderlich
The type of the input item. Always input_image.
detail
enum
Erforderlich
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
Erforderlich
The breakpoint mode. Always explicit.
type
enum
Erforderlich
The type of the input item. Always input_file.
filename
string
The name of the file to be sent to the model.
file_data
string
The content of the file to be sent to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
Erforderlich
The breakpoint mode. Always explicit.
file_url
string
The URL of the file to be sent to the model.
detail
enum
service_tier
enum
Specifies the processing type used for serving the request. - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'. - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model. - If set to 'flex', then the request will be processed with the Flex Processing service tier. - To opt-in to Fast mode at the request level, include the service_tier=fast or service_tier=priority parameter for Responses or Chat Completions. The response will show service_tier=priority regardless of if you specify service_tier=fast or priority in your request. - If set to 'ultrafast', then the request will be processed with the access-controlled Ultrafast Processing service tier. This tier is currently available for gpt-5.6-sol; a response served through it will show service_tier=ultrafast. - When not set, the default behavior is 'auto'. When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.
truncation
enum
id
string
Erforderlich
Unique identifier for this Response.
object
enum
Erforderlich
The object type of this resource - always set to response.
status
enum
The status of the response generation. One of completed, failed, in_progress, cancelled, queued, or incomplete.
access_programs
OpenAI.AccessProgramsBody | null
Erforderlich
cyber
enum
Erforderlich
created_at
integer
Erforderlich
Unix timestamp (in seconds) of when this Response was created.
error
OpenAI.ResponseError | null
Erforderlich
An error object returned when the model fails to generate a Response.
type
string | null
The original error type, or null if it was not recorded.
param
string | null
The request parameter associated with the error, or null if none was recorded.
code
enum
Erforderlich
The error code for the response.
message
string
Erforderlich
A human-readable description of the error.
misalignment
OpenAI.MisalignmentErrorDetailsResource
error_type
string | enum
enum
detailed_explanation
string
The public explanation for this block.
steer
OpenAI._MisalignmentSteer
message
string
Erforderlich
The public continuation instruction.
incomplete_details
OpenAI.ResponseIncompleteDetails | null
Erforderlich
reason
enum
output
OpenAI.OutputItem[]
Erforderlich
An array of content items generated by the model. - The length and order of items in the output array is dependent on the model's response. - Rather than accessing the first item in the output array and assuming it's an assistant message with the content generated by the model, you might consider using the output_text property where supported in SDKs.
reasoning
OpenAI.Reasoning | null
Configuration options for reasoning models.
mode
string | enum
enum
effort
string | enum | null
Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, xhigh, and max. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response. Not all reasoning models support every value. See the reasoning guide for model-specific support.
enum
summary
enum
context
enum
generate_summary
enum
instructions
string | OpenAI.InputItem[] | null
Erforderlich
usage
OpenAI.ResponseUsage | null
Represents token usage details including input tokens, output tokens, a breakdown of output tokens, and the total tokens used.
input_tokens_details
OpenAI.ResponseUsageInputTokensDetails
Erforderlich
output_tokens_details
OpenAI.ResponseUsageOutputTokensDetails
Erforderlich
prompt_cache_options
OpenAI.PromptCacheOptions
The prompt-caching options that were applied to the response. Supported for gpt-5.6 and later models.
ttl
enum
Erforderlich
mode
enum
Erforderlich
prompt_cache_diagnostics
cache_miss | cache_hit | comparison_response_not_found | unavailable
Prompt cache diagnostics requested for this response.
cache_miss
OpenAI.PromptCacheMissDiagnosticsBody
type
enum
Erforderlich
reason
enum
Erforderlich
cache_hit
OpenAI.PromptCacheHitDiagnosticsBody
type
enum
Erforderlich
comparison_response_not_found
OpenAI.PromptCacheComparisonResponseNotFoundDiagnosticsBody
type
enum
Erforderlich
unavailable
OpenAI.PromptCacheUnavailableDiagnosticsBody
type
enum
Erforderlich
moderation
OpenAI.Moderation | null
Moderation results or errors for the response input and output.
input
error | moderation_result
Erforderlich
Moderation results or an error for a response moderation check.
error
OpenAI.ModerationErrorBody
An error produced while attempting moderation for the response input or output.
type
enum
Erforderlich
The object type, which was always error for moderation failures.
code
string
Erforderlich
The error code.
message
string
Erforderlich
The error message.
moderation_result
OpenAI.ModerationResultBody
A moderation result produced for the response input or output.
type
enum
Erforderlich
The object type, which was always moderation_result for successful moderation results.
model
string
Erforderlich
The moderation model that produced this result.
flagged
boolean
Erforderlich
A boolean indicating whether the content was flagged by any category.
categories
object
Erforderlich
A dictionary of moderation categories to booleans, True if the input is flagged under this category.
category_scores
object
Erforderlich
A dictionary of moderation categories to scores.
category_applied_input_types
object
Erforderlich
Which modalities of input are reflected by the score for each category.
output
error | moderation_result
Erforderlich
Moderation results or an error for a response moderation check.
error
OpenAI.ModerationErrorBody
An error produced while attempting moderation for the response input or output.
type
enum
Erforderlich
The object type, which was always error for moderation failures.
code
string
Erforderlich
The error code.
message
string
Erforderlich
The error message.
moderation_result
OpenAI.ModerationResultBody
A moderation result produced for the response input or output.
type
enum
Erforderlich
The object type, which was always moderation_result for successful moderation results.
model
string
Erforderlich
The moderation model that produced this result.
flagged
boolean
Erforderlich
A boolean indicating whether the content was flagged by any category.
categories
object
Erforderlich
A dictionary of moderation categories to booleans, True if the input is flagged under this category.
category_scores
object
Erforderlich
A dictionary of moderation categories to scores.
category_applied_input_types
object
Erforderlich
Which modalities of input are reflected by the score for each category.
parallel_tool_calls
boolean
Erforderlich
Whether to allow the model to run tool calls in parallel.
conversation
OpenAI.ResponseConversation | null
The conversation that this response belonged to. Input items and output items from this response were automatically added to this conversation.
id
string
Erforderlich
The unique ID of the conversation that this response was associated with.
agent_reference
AgentReference | null
Erforderlich
The agent used for this response
type
enum
Erforderlich
name
string
Erforderlich
The name of the agent.
version
string
The version identifier of the agent.
model_selection_details
ModelSelectionDetails
Model selection metadata providing visibility into routing decisions.
model_router_details
ModelRouterDetails
Erforderlich
Routing decision metadata from Model Router.
mode
string | enum
Erforderlich
The routing mode used by Model Router for the request.
enum
session_affinity
SessionAffinityDetails
Effective Model Router session affinity metadata for a request.
mode
string | enum
Erforderlich
Effective modes reported for Model Router session affinity.
enum
source
string | enum
Conversation identifier sources supported by Model Router session affinity.
enum
decision
string | enum
Final outcomes reported for Model Router session affinity.
enum
routing_trace
RoutingTraceEntry[]
Erforderlich
Ordered trace of routing decisions. Contains one entry for Chat Completions, and may contain multiple entries for Responses API or agent scenarios where multiple inference turns occur.
content_filters
ContentFilterResult[]
The content filter evaluation results.
type
enum
Erforderlich
The type of the event. Always response.failed.
response
OpenAI.Response
Erforderlich
metadata
OpenAI.Metadata | null
Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
user
string | null
This field is being replaced by safety_identifier and prompt_cache_key. Use prompt_cache_key instead to maintain caching optimizations. A stable identifier for your end-users. Used to boost cache hit rates by better bucketing similar requests and to help OpenAI detect and prevent abuse. Learn more.
prompt_cache_retention
enum
model
string
The model deployment to use for the creation of this response.
text
OpenAI.ResponseTextParam
Configuration options for a text response from the model. Can be plain text or structured JSON data. Learn more: - Text inputs and outputs - Structured Outputs
format
json_schema | text | json_object
An object specifying the format that the model must output. Configuring { "type": "json_schema" } enables Structured Outputs, which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide. The default format is { "type": "text" } with no additional options. Not recommended for gpt-4o and newer models:* Setting to { "type": "json_object" } enables the older JSON mode, which ensures the message the model generates is valid JSON. Using json_schema is preferred for models that support it.
json_schema
OpenAI.TextResponseFormatJsonSchema
JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
type
enum
Erforderlich
The type of response format being defined. Always json_schema.
description
string
A description of what the response format is for, used by the model to determine how to respond in the format.
name
string
Erforderlich
The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
schema
OpenAI.ResponseFormatJsonSchemaSchema
Erforderlich
The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
text
OpenAI.TextResponseFormatConfigurationResponseFormatText
Default response format. Used to generate text responses.
type
enum
Erforderlich
The type of response format being defined. Always text.
json_object
OpenAI.TextResponseFormatConfigurationResponseFormatJsonObject
JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.
type
enum
Erforderlich
The type of response format being defined. Always json_object.
verbosity
enum
Constrains the verbosity of the model's response. Lower values will result in more concise responses, while higher values will result in more verbose responses. Currently supported values are low, medium, and high. The default is medium.
tools
OpenAI.Tool[]
An array of tools the model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter. We support the following categories of tools: - Built-in tools: Tools that are provided by OpenAI that extend the model's capabilities, like web search or file search. Learn more about built-in tools. - MCP Tools: Integrations with third-party systems via custom MCP servers or predefined connectors such as Google Drive and SharePoint. Learn more about MCP Tools. - Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code with strongly typed arguments and outputs. Learn more about function calling. You can also use custom tools to call your own code.
tool_choice
enum | OpenAI.ToolChoiceParam
enum
Controls which (if any) tool is called by the model. none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools.
function
OpenAI.ToolChoiceFunction
Use this option to force the model to call a specific function.
type
enum
Erforderlich
For function calling, the type is always function.
name
string
Erforderlich
The name of the function to call.
mcp
OpenAI.ToolChoiceMCP
Use this option to force the model to call a specific tool on a remote MCP server.
type
enum
Erforderlich
For MCP tools, the type is always mcp.
server_label
string
Erforderlich
The label of the MCP server to use.
allowed_tools
OpenAI.ToolChoiceAllowed
Constrains the tools available to the model to a pre-defined set.
type
enum
Erforderlich
Allowed tool configuration type. Always allowed_tools.
mode
enum
Erforderlich
Constrains the tools available to the model to a pre-defined set. auto allows the model to pick from among the allowed tools and generate a message. required requires the model to call one or more of the allowed tools.
tools
object[]
Erforderlich
A list of tool definitions that the model should be allowed to call. For the Responses API, the list of tool definitions might look like: json [ { "type": "function", "name": "get_weather" }, { "type": "mcp", "server_label": "deepwiki" }, { "type": "image_generation" } ]
custom
OpenAI.ToolChoiceCustom
Use this option to force the model to call a specific custom tool.
type
enum
Erforderlich
For custom tool calling, the type is always custom.
name
string
Erforderlich
The name of the custom tool to call.
programmatic_tool_calling
OpenAI.SpecificProgrammaticToolCallingParam
type
enum
Erforderlich
The tool to call. Always programmatic_tool_calling.
apply_patch
OpenAI.SpecificApplyPatchParam
Forces the model to call the apply_patch tool when executing a tool call.
type
enum
Erforderlich
The tool to call. Always apply_patch.
shell
OpenAI.SpecificFunctionShellParam
Forces the model to call the shell tool when a tool call is required.
type
enum
Erforderlich
The tool to call. Always shell.
file_search
OpenAI.ToolChoiceFileSearch
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
web_search_preview
OpenAI.ToolChoiceWebSearchPreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
computer_use_preview
OpenAI.ToolChoiceComputerUsePreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
web_search_preview_2025_03_11
OpenAI.ToolChoiceWebSearchPreview20250311
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
image_generation
OpenAI.ToolChoiceImageGeneration
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
code_interpreter
OpenAI.ToolChoiceCodeInterpreter
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
computer
OpenAI.ToolChoiceComputer
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
computer_use
OpenAI.ToolChoiceComputerUse
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
prompt
OpenAI.Prompt
Reference to a prompt template and its variables. Learn more.
id
string
Erforderlich
The unique identifier of the prompt template to use.
variables
OpenAI.ResponsePromptVariables | null
Optional map of values to substitute in for variables in your prompt. The substitution values can either be strings, or other Response input types like images or files.
[key: string]
string | OpenAI.InputTextContent | OpenAI.InputImageContent | OpenAI.InputFileContent
type
enum
Erforderlich
The type of the input item. Always input_text.
text
string
Erforderlich
The text input to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
Erforderlich
The breakpoint mode. Always explicit.
type
enum
Erforderlich
The type of the input item. Always input_image.
detail
enum
Erforderlich
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
Erforderlich
The breakpoint mode. Always explicit.
type
enum
Erforderlich
The type of the input item. Always input_file.
filename
string
The name of the file to be sent to the model.
file_data
string
The content of the file to be sent to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
Erforderlich
The breakpoint mode. Always explicit.
file_url
string
The URL of the file to be sent to the model.
detail
enum
service_tier
enum
Specifies the processing type used for serving the request. - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'. - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model. - If set to 'flex', then the request will be processed with the Flex Processing service tier. - To opt-in to Fast mode at the request level, include the service_tier=fast or service_tier=priority parameter for Responses or Chat Completions. The response will show service_tier=priority regardless of if you specify service_tier=fast or priority in your request. - If set to 'ultrafast', then the request will be processed with the access-controlled Ultrafast Processing service tier. This tier is currently available for gpt-5.6-sol; a response served through it will show service_tier=ultrafast. - When not set, the default behavior is 'auto'. When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.
truncation
enum
id
string
Erforderlich
Unique identifier for this Response.
object
enum
Erforderlich
The object type of this resource - always set to response.
status
enum
The status of the response generation. One of completed, failed, in_progress, cancelled, queued, or incomplete.
access_programs
OpenAI.AccessProgramsBody | null
Erforderlich
cyber
enum
Erforderlich
created_at
integer
Erforderlich
Unix timestamp (in seconds) of when this Response was created.
error
OpenAI.ResponseError | null
Erforderlich
An error object returned when the model fails to generate a Response.
type
string | null
The original error type, or null if it was not recorded.
param
string | null
The request parameter associated with the error, or null if none was recorded.
code
enum
Erforderlich
The error code for the response.
message
string
Erforderlich
A human-readable description of the error.
misalignment
OpenAI.MisalignmentErrorDetailsResource
error_type
string | enum
enum
detailed_explanation
string
The public explanation for this block.
steer
OpenAI._MisalignmentSteer
message
string
Erforderlich
The public continuation instruction.
incomplete_details
OpenAI.ResponseIncompleteDetails | null
Erforderlich
reason
enum
output
OpenAI.OutputItem[]
Erforderlich
An array of content items generated by the model. - The length and order of items in the output array is dependent on the model's response. - Rather than accessing the first item in the output array and assuming it's an assistant message with the content generated by the model, you might consider using the output_text property where supported in SDKs.
reasoning
OpenAI.Reasoning | null
Configuration options for reasoning models.
mode
string | enum
enum
effort
string | enum | null
Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, xhigh, and max. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response. Not all reasoning models support every value. See the reasoning guide for model-specific support.
enum
summary
enum
context
enum
generate_summary
enum
instructions
string | OpenAI.InputItem[] | null
Erforderlich
usage
OpenAI.ResponseUsage | null
Represents token usage details including input tokens, output tokens, a breakdown of output tokens, and the total tokens used.
input_tokens_details
OpenAI.ResponseUsageInputTokensDetails
Erforderlich
output_tokens_details
OpenAI.ResponseUsageOutputTokensDetails
Erforderlich
prompt_cache_options
OpenAI.PromptCacheOptions
The prompt-caching options that were applied to the response. Supported for gpt-5.6 and later models.
ttl
enum
Erforderlich
mode
enum
Erforderlich
prompt_cache_diagnostics
cache_miss | cache_hit | comparison_response_not_found | unavailable
Prompt cache diagnostics requested for this response.
cache_miss
OpenAI.PromptCacheMissDiagnosticsBody
type
enum
Erforderlich
reason
enum
Erforderlich
cache_hit
OpenAI.PromptCacheHitDiagnosticsBody
type
enum
Erforderlich
comparison_response_not_found
OpenAI.PromptCacheComparisonResponseNotFoundDiagnosticsBody
type
enum
Erforderlich
unavailable
OpenAI.PromptCacheUnavailableDiagnosticsBody
type
enum
Erforderlich
moderation
OpenAI.Moderation | null
Moderation results or errors for the response input and output.
input
error | moderation_result
Erforderlich
Moderation results or an error for a response moderation check.
error
OpenAI.ModerationErrorBody
An error produced while attempting moderation for the response input or output.
type
enum
Erforderlich
The object type, which was always error for moderation failures.
code
string
Erforderlich
The error code.
message
string
Erforderlich
The error message.
moderation_result
OpenAI.ModerationResultBody
A moderation result produced for the response input or output.
type
enum
Erforderlich
The object type, which was always moderation_result for successful moderation results.
model
string
Erforderlich
The moderation model that produced this result.
flagged
boolean
Erforderlich
A boolean indicating whether the content was flagged by any category.
categories
object
Erforderlich
A dictionary of moderation categories to booleans, True if the input is flagged under this category.
category_scores
object
Erforderlich
A dictionary of moderation categories to scores.
category_applied_input_types
object
Erforderlich
Which modalities of input are reflected by the score for each category.
output
error | moderation_result
Erforderlich
Moderation results or an error for a response moderation check.
error
OpenAI.ModerationErrorBody
An error produced while attempting moderation for the response input or output.
type
enum
Erforderlich
The object type, which was always error for moderation failures.
code
string
Erforderlich
The error code.
message
string
Erforderlich
The error message.
moderation_result
OpenAI.ModerationResultBody
A moderation result produced for the response input or output.
type
enum
Erforderlich
The object type, which was always moderation_result for successful moderation results.
model
string
Erforderlich
The moderation model that produced this result.
flagged
boolean
Erforderlich
A boolean indicating whether the content was flagged by any category.
categories
object
Erforderlich
A dictionary of moderation categories to booleans, True if the input is flagged under this category.
category_scores
object
Erforderlich
A dictionary of moderation categories to scores.
category_applied_input_types
object
Erforderlich
Which modalities of input are reflected by the score for each category.
parallel_tool_calls
boolean
Erforderlich
Whether to allow the model to run tool calls in parallel.
conversation
OpenAI.ResponseConversation | null
The conversation that this response belonged to. Input items and output items from this response were automatically added to this conversation.
id
string
Erforderlich
The unique ID of the conversation that this response was associated with.
agent_reference
AgentReference | null
Erforderlich
The agent used for this response
type
enum
Erforderlich
name
string
Erforderlich
The name of the agent.
version
string
The version identifier of the agent.
model_selection_details
ModelSelectionDetails
Model selection metadata providing visibility into routing decisions.
model_router_details
ModelRouterDetails
Erforderlich
Routing decision metadata from Model Router.
mode
string | enum
Erforderlich
The routing mode used by Model Router for the request.
enum
session_affinity
SessionAffinityDetails
Effective Model Router session affinity metadata for a request.
mode
string | enum
Erforderlich
Effective modes reported for Model Router session affinity.
enum
source
string | enum
Conversation identifier sources supported by Model Router session affinity.
enum
decision
string | enum
Final outcomes reported for Model Router session affinity.
enum
routing_trace
RoutingTraceEntry[]
Erforderlich
Ordered trace of routing decisions. Contains one entry for Chat Completions, and may contain multiple entries for Responses API or agent scenarios where multiple inference turns occur.
content_filters
ContentFilterResult[]
The content filter evaluation results.
type
enum
Erforderlich
The type of the event. Always response.incomplete.
response
OpenAI.Response
Erforderlich
metadata
OpenAI.Metadata | null
Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
user
string | null
This field is being replaced by safety_identifier and prompt_cache_key. Use prompt_cache_key instead to maintain caching optimizations. A stable identifier for your end-users. Used to boost cache hit rates by better bucketing similar requests and to help OpenAI detect and prevent abuse. Learn more.
prompt_cache_retention
enum
model
string
The model deployment to use for the creation of this response.
text
OpenAI.ResponseTextParam
Configuration options for a text response from the model. Can be plain text or structured JSON data. Learn more: - Text inputs and outputs - Structured Outputs
format
json_schema | text | json_object
An object specifying the format that the model must output. Configuring { "type": "json_schema" } enables Structured Outputs, which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide. The default format is { "type": "text" } with no additional options. Not recommended for gpt-4o and newer models:* Setting to { "type": "json_object" } enables the older JSON mode, which ensures the message the model generates is valid JSON. Using json_schema is preferred for models that support it.
json_schema
OpenAI.TextResponseFormatJsonSchema
JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
type
enum
Erforderlich
The type of response format being defined. Always json_schema.
description
string
A description of what the response format is for, used by the model to determine how to respond in the format.
name
string
Erforderlich
The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
schema
OpenAI.ResponseFormatJsonSchemaSchema
Erforderlich
The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
text
OpenAI.TextResponseFormatConfigurationResponseFormatText
Default response format. Used to generate text responses.
type
enum
Erforderlich
The type of response format being defined. Always text.
json_object
OpenAI.TextResponseFormatConfigurationResponseFormatJsonObject
JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.
type
enum
Erforderlich
The type of response format being defined. Always json_object.
verbosity
enum
Constrains the verbosity of the model's response. Lower values will result in more concise responses, while higher values will result in more verbose responses. Currently supported values are low, medium, and high. The default is medium.
tools
OpenAI.Tool[]
An array of tools the model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter. We support the following categories of tools: - Built-in tools: Tools that are provided by OpenAI that extend the model's capabilities, like web search or file search. Learn more about built-in tools. - MCP Tools: Integrations with third-party systems via custom MCP servers or predefined connectors such as Google Drive and SharePoint. Learn more about MCP Tools. - Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code with strongly typed arguments and outputs. Learn more about function calling. You can also use custom tools to call your own code.
tool_choice
enum | OpenAI.ToolChoiceParam
enum
Controls which (if any) tool is called by the model. none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools.
function
OpenAI.ToolChoiceFunction
Use this option to force the model to call a specific function.
type
enum
Erforderlich
For function calling, the type is always function.
name
string
Erforderlich
The name of the function to call.
mcp
OpenAI.ToolChoiceMCP
Use this option to force the model to call a specific tool on a remote MCP server.
type
enum
Erforderlich
For MCP tools, the type is always mcp.
server_label
string
Erforderlich
The label of the MCP server to use.
allowed_tools
OpenAI.ToolChoiceAllowed
Constrains the tools available to the model to a pre-defined set.
type
enum
Erforderlich
Allowed tool configuration type. Always allowed_tools.
mode
enum
Erforderlich
Constrains the tools available to the model to a pre-defined set. auto allows the model to pick from among the allowed tools and generate a message. required requires the model to call one or more of the allowed tools.
tools
object[]
Erforderlich
A list of tool definitions that the model should be allowed to call. For the Responses API, the list of tool definitions might look like: json [ { "type": "function", "name": "get_weather" }, { "type": "mcp", "server_label": "deepwiki" }, { "type": "image_generation" } ]
custom
OpenAI.ToolChoiceCustom
Use this option to force the model to call a specific custom tool.
type
enum
Erforderlich
For custom tool calling, the type is always custom.
name
string
Erforderlich
The name of the custom tool to call.
programmatic_tool_calling
OpenAI.SpecificProgrammaticToolCallingParam
type
enum
Erforderlich
The tool to call. Always programmatic_tool_calling.
apply_patch
OpenAI.SpecificApplyPatchParam
Forces the model to call the apply_patch tool when executing a tool call.
type
enum
Erforderlich
The tool to call. Always apply_patch.
shell
OpenAI.SpecificFunctionShellParam
Forces the model to call the shell tool when a tool call is required.
type
enum
Erforderlich
The tool to call. Always shell.
file_search
OpenAI.ToolChoiceFileSearch
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
web_search_preview
OpenAI.ToolChoiceWebSearchPreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
computer_use_preview
OpenAI.ToolChoiceComputerUsePreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
web_search_preview_2025_03_11
OpenAI.ToolChoiceWebSearchPreview20250311
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
image_generation
OpenAI.ToolChoiceImageGeneration
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
code_interpreter
OpenAI.ToolChoiceCodeInterpreter
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
computer
OpenAI.ToolChoiceComputer
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
computer_use
OpenAI.ToolChoiceComputerUse
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
Erforderlich
prompt
OpenAI.Prompt
Reference to a prompt template and its variables. Learn more.
id
string
Erforderlich
The unique identifier of the prompt template to use.
variables
OpenAI.ResponsePromptVariables | null
Optional map of values to substitute in for variables in your prompt. The substitution values can either be strings, or other Response input types like images or files.
[key: string]
string | OpenAI.InputTextContent | OpenAI.InputImageContent | OpenAI.InputFileContent
type
enum
Erforderlich
The type of the input item. Always input_text.
text
string
Erforderlich
The text input to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
Erforderlich
The breakpoint mode. Always explicit.
type
enum
Erforderlich
The type of the input item. Always input_image.
detail
enum
Erforderlich
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
Erforderlich
The breakpoint mode. Always explicit.
type
enum
Erforderlich
The type of the input item. Always input_file.
filename
string
The name of the file to be sent to the model.
file_data
string
The content of the file to be sent to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
Erforderlich
The breakpoint mode. Always explicit.
file_url
string
The URL of the file to be sent to the model.
detail
enum
service_tier
enum
Specifies the processing type used for serving the request. - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'. - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model. - If set to 'flex', then the request will be processed with the Flex Processing service tier. - To opt-in to Fast mode at the request level, include the service_tier=fast or service_tier=priority parameter for Responses or Chat Completions. The response will show service_tier=priority regardless of if you specify service_tier=fast or priority in your request. - If set to 'ultrafast', then the request will be processed with the access-controlled Ultrafast Processing service tier. This tier is currently available for gpt-5.6-sol; a response served through it will show service_tier=ultrafast. - When not set, the default behavior is 'auto'. When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.
truncation
enum
id
string
Erforderlich
Unique identifier for this Response.
object
enum
Erforderlich
The object type of this resource - always set to response.
status
enum
The status of the response generation. One of completed, failed, in_progress, cancelled, queued, or incomplete.
access_programs
OpenAI.AccessProgramsBody | null
Erforderlich
cyber
enum
Erforderlich
created_at
integer
Erforderlich
Unix timestamp (in seconds) of when this Response was created.
error
OpenAI.ResponseError | null
Erforderlich
An error object returned when the model fails to generate a Response.
type
string | null
The original error type, or null if it was not recorded.
param
string | null
The request parameter associated with the error, or null if none was recorded.
code
enum
Erforderlich
The error code for the response.
message
string
Erforderlich
A human-readable description of the error.
misalignment
OpenAI.MisalignmentErrorDetailsResource
error_type
string | enum
enum
detailed_explanation
string
The public explanation for this block.
steer
OpenAI._MisalignmentSteer
message
string
Erforderlich
The public continuation instruction.
incomplete_details
OpenAI.ResponseIncompleteDetails | null
Erforderlich
reason
enum
output
OpenAI.OutputItem[]
Erforderlich
An array of content items generated by the model. - The length and order of items in the output array is dependent on the model's response. - Rather than accessing the first item in the output array and assuming it's an assistant message with the content generated by the model, you might consider using the output_text property where supported in SDKs.
reasoning
OpenAI.Reasoning | null
Configuration options for reasoning models.
mode
string | enum
enum
effort
string | enum | null
Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, xhigh, and max. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response. Not all reasoning models support every value. See the reasoning guide for model-specific support.
enum
summary
enum
context
enum
generate_summary
enum
instructions
string | OpenAI.InputItem[] | null
Erforderlich
usage
OpenAI.ResponseUsage | null
Represents token usage details including input tokens, output tokens, a breakdown of output tokens, and the total tokens used.
input_tokens_details
OpenAI.ResponseUsageInputTokensDetails
Erforderlich
output_tokens_details
OpenAI.ResponseUsageOutputTokensDetails
Erforderlich
prompt_cache_options
OpenAI.PromptCacheOptions
The prompt-caching options that were applied to the response. Supported for gpt-5.6 and later models.
ttl
enum
Erforderlich
mode
enum
Erforderlich
prompt_cache_diagnostics
cache_miss | cache_hit | comparison_response_not_found | unavailable
Prompt cache diagnostics requested for this response.
cache_miss
OpenAI.PromptCacheMissDiagnosticsBody
type
enum
Erforderlich
reason
enum
Erforderlich
cache_hit
OpenAI.PromptCacheHitDiagnosticsBody
type
enum
Erforderlich
comparison_response_not_found
OpenAI.PromptCacheComparisonResponseNotFoundDiagnosticsBody
type
enum
Erforderlich
unavailable
OpenAI.PromptCacheUnavailableDiagnosticsBody
type
enum
Erforderlich
moderation
OpenAI.Moderation | null
Moderation results or errors for the response input and output.
input
error | moderation_result
Erforderlich
Moderation results or an error for a response moderation check.
error
OpenAI.ModerationErrorBody
An error produced while attempting moderation for the response input or output.
type
enum
Erforderlich
The object type, which was always error for moderation failures.
code
string
Erforderlich
The error code.
message
string
Erforderlich
The error message.
moderation_result
OpenAI.ModerationResultBody
A moderation result produced for the response input or output.
type
enum
Erforderlich
The object type, which was always moderation_result for successful moderation results.
model
string
Erforderlich
The moderation model that produced this result.
flagged
boolean
Erforderlich
A boolean indicating whether the content was flagged by any category.
categories
object
Erforderlich
A dictionary of moderation categories to booleans, True if the input is flagged under this category.
category_scores
object
Erforderlich
A dictionary of moderation categories to scores.
category_applied_input_types
object
Erforderlich
Which modalities of input are reflected by the score for each category.
output
error | moderation_result
Erforderlich
Moderation results or an error for a response moderation check.
error
OpenAI.ModerationErrorBody
An error produced while attempting moderation for the response input or output.
type
enum
Erforderlich
The object type, which was always error for moderation failures.
code
string
Erforderlich
The error code.
message
string
Erforderlich
The error message.
moderation_result
OpenAI.ModerationResultBody
A moderation result produced for the response input or output.
type
enum
Erforderlich
The object type, which was always moderation_result for successful moderation results.
model
string
Erforderlich
The moderation model that produced this result.
flagged
boolean
Erforderlich
A boolean indicating whether the content was flagged by any category.
categories
object
Erforderlich
A dictionary of moderation categories to booleans, True if the input is flagged under this category.
category_scores
object
Erforderlich
A dictionary of moderation categories to scores.
category_applied_input_types
object
Erforderlich
Which modalities of input are reflected by the score for each category.
parallel_tool_calls
boolean
Erforderlich
Whether to allow the model to run tool calls in parallel.
conversation
OpenAI.ResponseConversation | null
The conversation that this response belonged to. Input items and output items from this response were automatically added to this conversation.
id
string
Erforderlich
The unique ID of the conversation that this response was associated with.
agent_reference
AgentReference | null
Erforderlich
The agent used for this response
type
enum
Erforderlich
name
string
Erforderlich
The name of the agent.
version
string
The version identifier of the agent.
model_selection_details
ModelSelectionDetails
Model selection metadata providing visibility into routing decisions.
model_router_details
ModelRouterDetails
Erforderlich
Routing decision metadata from Model Router.
mode
string | enum
Erforderlich
The routing mode used by Model Router for the request.
enum
session_affinity
SessionAffinityDetails
Effective Model Router session affinity metadata for a request.
mode
string | enum
Erforderlich
Effective modes reported for Model Router session affinity.
enum
source
string | enum
Conversation identifier sources supported by Model Router session affinity.
enum
decision
string | enum
Final outcomes reported for Model Router session affinity.
enum
routing_trace
RoutingTraceEntry[]
Erforderlich
Ordered trace of routing decisions. Contains one entry for Chat Completions, and may contain multiple entries for Responses API or agent scenarios where multiple inference turns occur.
content_filters
ContentFilterResult[]
The content filter evaluation results.
type
enum
Erforderlich
The type of the event. Always response.output_item.added.
item
structured_outputs | workflow_action | oauth_consent_request | bing_grounding_call | bing_grounding_call_output | sharepoint_grounding_preview_call | sharepoint_grounding_preview_call_output | azure_ai_search_call | azure_ai_search_call_output | bing_custom_search_preview_call | bing_custom_search_preview_call_output | openapi_call | openapi_call_output | browser_automation_preview_call | browser_automation_preview_call_output | fabric_dataagent_preview_call | fabric_dataagent_preview_call_output | azure_function_call | azure_function_call_output | a2a_preview_call | a2a_preview_call_output | memory_search_call | memory_command_preview_call | memory_command_preview_call_output | output_message | file_search_call | function_call | function_call_output | web_search_call | computer_call | computer_call_output | reasoning | program | program_output | tool_search_call | tool_search_output | additional_tools | compaction | image_generation_call | code_interpreter_call | local_shell_call | local_shell_call_output | shell_call | shell_call_output | apply_patch_call | apply_patch_call_output | mcp_call | mcp_list_tools | mcp_approval_request | mcp_approval_response | custom_tool_call | custom_tool_call_output
Erforderlich
structured_outputs
StructuredOutputsOutputItem
type
enum
Erforderlich
output
StructuredOutputsOutputItem
Erforderlich
The structured output captured during the response.
workflow_action
WorkflowActionOutputItem
type
enum
Erforderlich
kind
string
Erforderlich
The kind of CSDL action (e.g., 'SetVariable', 'InvokeAzureAgent').
action_id
string
Erforderlich
Unique identifier for the action.
parent_action_id
string
ID of the parent action if this is a nested action.
previous_action_id
string
ID of the previous action if this action follows another.
status
enum
Erforderlich
Status of the action (e.g., 'in_progress', 'completed', 'failed', 'cancelled').
oauth_consent_request
OAuthConsentRequestOutputItem
Request from the service for the user to perform OAuth consent.
type
enum
Erforderlich
consent_link
string
Erforderlich
The link the user can use to perform OAuth consent.
server_label
string
Erforderlich
The server label for the OAuth consent request.
bing_grounding_call
BingGroundingToolCall
A Bing grounding tool call.
type
enum
Erforderlich
call_id
string
Erforderlich
The unique ID of the tool call generated by the model.
arguments
string
Erforderlich
A JSON string of the arguments to pass to the tool.
status
enum
Erforderlich
The status of a tool call.
bing_grounding_call_output
BingGroundingToolCallOutput
The output of a Bing grounding tool call.
type
enum
Erforderlich
call_id
string
Erforderlich
The unique ID of the tool call generated by the model.
output
object | string | any[]
The output content from a tool call, which can be a dictionary, string, or array.
status
enum
Erforderlich
The status of a tool call.
sharepoint_grounding_preview_call
SharepointGroundingToolCall
A SharePoint grounding tool call.
type
enum
Erforderlich
call_id
string
Erforderlich
The unique ID of the tool call generated by the model.
arguments
string
Erforderlich
A JSON string of the arguments to pass to the tool.
status
enum
Erforderlich
The status of a tool call.
sharepoint_grounding_preview_call_output
SharepointGroundingToolCallOutput
The output of a SharePoint grounding tool call.
type
enum
Erforderlich
call_id
string
Erforderlich
The unique ID of the tool call generated by the model.
output
object | string | any[]
The output content from a tool call, which can be a dictionary, string, or array.
status
enum
Erforderlich
The status of a tool call.
azure_ai_search_call
AzureAISearchToolCall
An Azure AI Search tool call.
type
enum
Erforderlich
call_id
string
Erforderlich
The unique ID of the tool call generated by the model.
arguments
string
Erforderlich
A JSON string of the arguments to pass to the tool.
status
enum
Erforderlich
The status of a tool call.
azure_ai_search_call_output
AzureAISearchToolCallOutput
The output of an Azure AI Search tool call.
type
enum
Erforderlich
call_id
string
Erforderlich
The unique ID of the tool call generated by the model.
output
object | string | any[]
The output content from a tool call, which can be a dictionary, string, or array.
status
enum
Erforderlich
The status of a tool call.
bing_custom_search_preview_call
BingCustomSearchToolCall
A Bing custom search tool call.
type
enum
Erforderlich
call_id
string
Erforderlich
The unique ID of the tool call generated by the model.
arguments
string
Erforderlich
A JSON string of the arguments to pass to the tool.
status
enum
Erforderlich
The status of a tool call.
bing_custom_search_preview_call_output
BingCustomSearchToolCallOutput
The output of a Bing custom search tool call.
type
enum
Erforderlich
call_id
string
Erforderlich
The unique ID of the tool call generated by the model.
output
object | string | any[]
The output content from a tool call, which can be a dictionary, string, or array.
status
enum
Erforderlich
The status of a tool call.
openapi_call
OpenApiToolCall
An OpenAPI tool call.
type
enum
Erforderlich
call_id
string
Erforderlich
The unique ID of the tool call generated by the model.
name
string
Erforderlich
The name of the OpenAPI operation being called.
arguments
string
Erforderlich
A JSON string of the arguments to pass to the tool.
status
enum
Erforderlich
The status of a tool call.
openapi_call_output
OpenApiToolCallOutput
The output of an OpenAPI tool call.
type
enum
Erforderlich
call_id
string
Erforderlich
The unique ID of the tool call generated by the model.
name
string
Erforderlich
The name of the OpenAPI operation that was called.
output
object | string | any[]
The output content from a tool call, which can be a dictionary, string, or array.
status
enum
Erforderlich
The status of a tool call.
browser_automation_preview_call
BrowserAutomationToolCall
A browser automation tool call.
type
enum
Erforderlich
call_id
string
Erforderlich
The unique ID of the tool call generated by the model.
arguments
string
Erforderlich
A JSON string of the arguments to pass to the tool.
status
enum
Erforderlich
The status of a tool call.
browser_automation_preview_call_output
BrowserAutomationToolCallOutput
The output of a browser automation tool call.
type
enum
Erforderlich
call_id
string
Erforderlich
The unique ID of the tool call generated by the model.
output
object | string | any[]
The output content from a tool call, which can be a dictionary, string, or array.
status
enum
Erforderlich
The status of a tool call.
fabric_dataagent_preview_call
FabricDataAgentToolCall
A Fabric data agent tool call.
type
enum
Erforderlich
call_id
string
Erforderlich
The unique ID of the tool call generated by the model.
arguments
string
Erforderlich
A JSON string of the arguments to pass to the tool.
status
enum
Erforderlich
The status of a tool call.
fabric_dataagent_preview_call_output
FabricDataAgentToolCallOutput
The output of a Fabric data agent tool call.
type
enum
Erforderlich
call_id
string
Erforderlich
[...]
